include "aq.inc"
include "mazy.inc"
include "char.inc"

    dseg
vvram defs window.width * window.height
base.x	defb	0
base.y	defb	0
public base.x, base.y

x.offset equ (VRAM.width-32)/2
status.x equ x.offset + window.width + 2

    extrn map, map.step
    cseg

Chars:
    ; space
    defb	0,0
    ; wall
	defb	86h, 60h
    ; chars
	defb	7fh, 30h, 1ch, 70h, 1eh, 07h, 1ah, 70h
	defb	7fh, 30h, 20h, 70h, 0eah, 70h, 1ch, 70h
	defb	1ah, 70h, 7fh, 30h, 1ch, 70h, 1eh, 70h
	defb	20h, 70h, 7fh, 30h, 1ah, 70h, 0b5h, 70h
	defb	7fh, 30h, 1eh, 07h, 1bh, 70h, 1ah, 70h
	defb	7fh, 30h, 1fh, 70h, 00h, 00h, 1bh, 70h
	defb	1ah, 70h, 1bh, 70h, 7fh, 30h, 1eh, 70h
	defb	00h, 00h, 1ah, 70h, 7fh, 30h, 1fh, 07h
	defb	7fh, 30h, 00h, 00h, 1eh, 07h, 1ch, 70h
	defb	00h, 00h, 7fh, 30h, 1ah, 70h, 1eh, 70h
	defb	7fh, 30h, 1eh, 07h, 00h, 00h, 1bh, 70h
	defb	00h, 00h, 1ah, 70h, 7fh, 30h, 1eh, 70h
	defb	4fh, 70h, 4fh, 70h, 1dh, 05h, 1bh, 05h
	defb	87h, 20h, 87h, 20h, 1dh, 01h, 1bh, 01h
	defb	7fh, 70h, 0efh, 70h, 7fh, 70h, 0feh, 70h
	defb	2ah, 0c0h, 2ah, 0c0h, 2ah, 0c0h, 2ah, 0c0h
	defb	1bh, 70h, 1eh, 07h, 00h, 00h, 7fh, 30h
	defb	1eh, 70h, 7fh, 30h, 1dh, 70h, 00h, 00h
    ; knife
    defb	07h, 70h, 06h, 70h, 08h, 70h, 09h, 70h
    ; title 
	defb	0eah, 70h, 1ah, 07h, 1ah, 07h, 1bh, 07h
	defb	0eah, 70h, 0b5h, 70h, 0b5h, 70h, 7fh, 70h
	defb	0eah, 70h, 0b5h, 70h, 0b5h, 70h, 7fh, 70h
	defb	1bh, 70h, 1dh, 70h, 1dh, 70h, 1fh, 07h
	defb	00h, 00h, 1dh, 05h, 1ch, 05h, 1ch, 50h
	defb	0eah, 50h, 0b5h, 50h, 00h, 00h, 7fh, 50h
	defb	0eah, 50h, 1ah, 05h, 1fh, 05h, 7fh, 50h
	defb	1bh, 50h, 1dh, 50h, 00h, 00h, 1fh, 05h
	defb	1bh, 30h, 1fh, 03h, 1ch, 03h, 1ah, 03h
	defb	00h, 00h, 1ah, 30h, 1ah, 03h, 00h, 00h
	defb	1ah, 30h, 1ah, 03h, 00h, 00h, 00h, 00h
	defb	1bh, 30h, 1fh, 03h, 1fh, 03h, 1fh, 03h
	defb	0eah, 10h, 0b5h, 10h, 0eah, 10h, 0b5h, 10h
	defb	1bh, 10h, 1bh, 01h, 1dh, 01h, 1dh, 10h
	defb	00h, 00h, 0eah, 10h, 0b5h, 10h, 00h, 00h
	defb	00h, 00h, 1bh, 10h, 1dh, 10h, 00h, 00h

MapToVVram: public MapToVVram
    ld a,(base.y)
    ld l,a
    ld h,0
    add hl,hl   ;*2
    add hl,hl   ;*4
    add hl,hl   ;*8 : map.step
    ld de,map
    add hl,de
    ld a,(base.x)
    ld b,a
    srl a
    srl a
    srl a
    ld e,a
    ld d,0
    add hl,de
    ex de,hl
    ld c,1
    ld a,b
    and 07h
    do | while nz
        sla c
        dec a
    wend
    ld hl, vvram
    ld b, window.height
    do
        push bc
            push de
                ld b, window.width
                do
                    ld a,(de)
                    and c
                    if nz
                        ld (hl), Char.Wall
                    else
                        ld (hl), Char.Space
                    endif
                    inc hl
                    rlc c
                    if c
                        inc de
                    endif
                dwnz
            pop de
            ex de,hl
            ld bc, map.step
            add hl,bc
            ex de,hl
        pop bc
    dwnz
ret


ClearAll: 
    ; ld hl,vvram
    ; ld bc,window.width*window.height
    ; do
    ;     ld (hl),Char.Space | inc hl
    ;     dec bc
    ;     ld a,c
    ;     or b
    ; while nz | wend
    ld hl,VRAM
    ld bc,VRAM.width*VRAM.height
    do
        ld (hl),0 | inc hl
        dec bc
        ld a,c
        or b
    while nz | wend
    ld hl,Atributes
    ld bc,vram.width*vram.height
    do
        ld (hl),0 | inc hl
        dec bc
        ld a,c
        or b
    while nz | wend
ret

VVramToVram:    public VVramToVram
    ld de,VRAM + x.offset
    ld hl,Atributes+ x.offset
    exx
        ld de,vvram
        ld bc,Chars
    exx
    ld c, window.height ; vertical count    
    do
        push bc
            ld b,window.width
            do 
                exx
                    ld a,(de)
                    inc de
                    ld l,a
                    ld h,0
                    add hl,hl ; *2
                    add hl,bc
                    ld a,(hl)
                    inc hl
                exx
                ld (de),a
                inc de
                exx
                    ld a,(hl)
                exx
                ld (hl),a
                inc hl
            dwnz
            ld bc,vram.width-window.width
            ex de,hl
                add hl,bc
            ex de,hl
            add hl,bc
        pop bc
        dec c
    while nz | wend
ret 

Put2x2:
    public Put2x2
; in
;   a: index
;   h: y
;   l: x
; use: except ix, iy
    ex af,af'
        ld bc,202h
        ld de, (base.x)
        ld a,l
        sub e
        if c
            inc a
            ret nz
            dec c
            ex af,af'
            inc a
            ex af,af'
        endif
        cp window.width
        ret nc
        cp window.width-1
        if z
            dec c
        endif
        ld l,a

        ld a,h
        sub d
        if c
            inc a
            ret nz
            dec b
            ex af,af'
            add a,2
            ex af,af'
        endif
        cp window.height
        ret nc
        cp window.height-1
        if z
            dec b
        endif
        ld h,a

        push bc
            ld c,l
            ld b,0
            ld l,h
            ld h,0
            add hl,hl   ;*2
            add hl,hl   ;*4
            add hl,hl   ;*8
            ld e,l
            ld d,h
            add hl,hl   ;*16
            add hl,de   ;*24
            ld de, vvram
            add hl, de
            add hl, bc
        pop bc
    ex af,af'
    ld de, window.width
    do
        push bc
        push hl
        push af
            ld b,c
            pc4.5:
                ld (hl),a
                inc hl
                inc a
            djnz pc4.5
        pop af
        pop hl
        pop bc
        add hl,de
        add a,2
    dwnz
ret


Put1x1:
    public Put1x1
; in
;   a: index
;   h: y
;   l: x
; use: except ix, iy
    ex af,af'
        ld bc,202h
        ld de, (base.x)

        ld a,l
        sub e
        ret c
        cp window.width
        ret nc
        ld l,a

        ld a,h
        sub d
        ret c
        cp window.height
        ret nc
        ld h,a

        ld c,l
        ld b,0
        ld l,h
        ld h,0
        add hl,hl   ;*2
        add hl,hl   ;*4
        add hl,hl   ;*8
        ld e,l
        ld d,h
        add hl,hl   ;*16
        add hl,de   ;*24
        ld de, vvram
        add hl, de
        add hl, bc
    ex af,af'
    ld (hl),a
ret


    extrn Kn.Invnt
Print.Kn.Invent:  public Print.Kn.Invent
    ld de, VRAM + status.x + vram.width*(window.height - 4)
    ld a,(Kn.Invnt)
    or a
    do | while nz
        push af
            ld a, Char.Kn.Left
            call Print1x1
        pop af
        inc de
        dec a
    wend
    ld a,(Kn.Invnt)
    neg
    add a,4
    do | while nz
        push af
            ld a, Char.Space
            call Print1x1
        pop af
        inc de
        dec a
    wend
ret 

PrintC: 
; in
;   de: address
;   a: char
; out
;   de: next address
; use af
    ld (de),a
    ld a,d
    add a,4
    ld d,a
    ld a,70h
    ld (de),a
    ld a,d
    sub 4
    ld d,a
    inc de
ret 

PrintS: 
; in
;   hl: string
;   de: address
; out
;   de: next address
; use hl af
    do
        ld a,(hl) | inc hl
        or a
    while nz
        call PrintC
    wend
ret 

extrn Score, HiScore, Stage, Stage.Time

Str.Score: defb 'SCORE',0
Str.High: defb 'HIGH',0
Str.Stage: defb 'STAGE',0
Str.Time: defb 'TIME',0

PrintStatus: public PrintStatus
    call ClearAll

    ld de, VRAM + status.x + vram.width * 0
    ld hl,Str.Score
    call PrintS

    ld de, VRAM + status.x + vram.width * 3
    ld hl,Str.High
    call PrintS
    ld de, VRAM + status.x + vram.width * 4
    ld hl,Str.Score
    call PrintS

    ld de, VRAM + status.x + vram.width * 7
    ld hl,Str.Stage
    call PrintS
    ld de, VRAM + status.x + vram.width * 8 + 4
    ld a,(Stage)
    inc a
    call PrintByte2

    ld de, VRAM + status.x + vram.width * 10
    ld hl,Str.Time
    call PrintS

    call PrintScore    
    call PrintTime
    call Print.Kn.Invent
jr Print.Men

PrintScore: public PrintScore
    ld hl,(Score)
    ld de, VRAM + status.x + vram.width * 1
    call PrintNumber
    ld a,'0'
    call PrintC

    ld hl,(HiScore)
    ld de, VRAM + status.x + vram.width * 5
    call PrintNumber
    ld a,'0'
    call PrintC
ret

PrintTime: public PrintTime
    ld hl,(Stage.Time)
    ld de, VRAM + status.x + vram.width * 11 + 3
jp PrintNumber3
   

PrintNumber:
; in
;   hl: number
;   de: address
; out
;   de: next address
; use af bc
    ld bc,10000
    call PrintDigit
    ld bc,1000
    call PrintDigit
    PrintNumber3:
    ld bc,100
    call PrintDigit
    ld bc,10
    call PrintDigit
    ld a,l
    add a,'0'
jp PrintC

PrintDigit:
    xor a
    do
        inc a
        sbc hl,bc
    while nc
    wend
    dec a
    add hl,bc
    add a,'0'
jp PrintC

PrintByte:
; in
;   a: number
;   de: address
; out
;   de: next address
; use af c
    ld c,100
    call PrintDigitB
PrintByte2:
    ld c,10
    call PrintDigitB
    add a,'0'
jp PrintC

PrintDigitB:
    ld b,0
    do
        inc b
        sub c
    while nc
    wend
    add a,c
    dec b
    push af
        ld a,b
        add a,'0'
        call PrintC
    pop af
ret 

Print1x1:
; in
;   a: char
;   de: vram address
; uses hl,de,bc,af,af'
    ld l,a
    ld h,0
    add hl,hl ; *2
    ld bc,Chars
    add hl,bc
    ex af,af'
        ld a,(hl)
        inc hl
        ld (de),a
        ld a,d
        add a,4
        ld d,a
        ld a,(hl)
        ld (de),a
        ld a,d
        sub 4
        ld d,a
    ex af,af'
ret

Print2x2:
; in
;   a: char
;   de: address
; use af
    push hl
    push bc
    push de
        ld c,2
        do
            ld b,2
            do
                push bc
                    push af
                        call Print1x1
                    pop af
                    inc de
                    inc a
                pop bc
            dwnz
            ex de,hl
                ld de, vram.width-2
                add hl,de
            ex de,hl
            dec c
        while nz | wend
    pop de
    pop bc
    pop hl
    inc de
    inc de
ret

extrn Man.Count

Print.Men:
    ld de, VRAM + status.x + vram.width * (window.height-2)
    ld a,(Man.Count)
    or a
    ret z
    do
        dec a
    while nz
        push af
            ld a,Char.Man.Stop.Left
            call Print2x2
        pop af
    wend
ret

WhiteBox:
    ld de, VRAM + x.offset + (window.width - 9)/2 + VRAM.width * (window.height/2 - 1)
    ld c,3
    do 
        ld b, 9
        do 
            push bc
                ld a,Char.Space
                call Print1x1
            pop bc
            inc de
        dwnz
        ex de,hl
            ld de, vram.width - 9
            add hl,de
        ex de,hl
        dec c
    while nz | wend
ret

Str.Over:   defb 'GAME OVER',0
Print.Over: public Print.Over
    call WhiteBox    
    ld de, VRAM + x.offset + (window.width - 9)/2 + VRAM.width * (window.height / 2)
    ld hl, Str.Over
jp PrintS

Str.Timeup:   defb 'TIME UP',0
PrintTimeup: public PrintTimeup
    call WhiteBox    
    ld de, VRAM + x.offset + (window.width - 7)/2 + VRAM.width * (window.height / 2)
    ld hl, Str.Timeup
jp PrintS

Print4x4:
; in
;   a: char
;   de: address
; use af
    push hl
    push bc
    push de
        ld c,4
        do
            ld b,4
            do
                push bc
                    push af
                        call Print1x1
                    pop af
                    inc de
                    inc a
                pop bc
            dwnz
            ex de,hl
                ld de, vram.width-4
                add hl,de
            ex de,hl
            dec c
        while nz | wend
    pop de
    pop bc
    pop hl
    inc de
    inc de
    inc de
    inc de
ret

Str.Chars: defb '--- CHARACTERS ---',0
Str.Man: defb 'MAN',0
Str.Chaser: defb 'CHASER',0
Str.Disturber: defb 'DISTURBER',0
Str.Exit: defb 'EXIT',0
Str.Push: defb 'PUSH SPACE KEY',0

TitleScreen: public TitleScreen
    call PrintStatus

    ld de,Vram  + x.offset + 4 + vram.width*1
    ld a, Char.Title
    ld b,4
    do
        push af
            call Print4x4
        pop af
        add a,16
    dwnz

    ld de,Vram + x.offset + 6 + vram.width*8
    ld a, Char.Man.Stop.Right
    call Print2x2

    ld de,Vram + x.offset + 6 + vram.width*11
    ld a, Char.Chaser
    call Print2x2

    ld de,Vram + x.offset + 6 + vram.width*14
    ld a, Char.Disturber
    call Print2x2

    ld de,Vram + x.offset + 6 + vram.width*17
    ld a, Char.Goal
    call Print2x2

    ld de, VRAM + x.offset + 4 + vram.width*6
    ld hl, Str.Chars
    call PrintS

    ld de, VRAM + x.offset + 10 + vram.width*9
    ld hl, Str.Man
    call PrintS

    ld de, VRAM + x.offset + 10 + vram.width*12
    ld hl, Str.Chaser
    call PrintS

    ld de, VRAM + x.offset + 10 + vram.width*15
    ld hl, Str.Disturber
    call PrintS

    ld de, VRAM + x.offset + 10 + vram.width*18
    ld hl, Str.Exit
    call PrintS

    ld de, VRAM + x.offset + 5 + vram.width*21
    ld hl, Str.Push
    call PrintS
ret 
